clear all
close all

dirlistm=dir('*-mask.mat');
dirlistb=dir('*-bkg.mat');

sub = [];
subn = [];
rep = [];
stu = [];
m_out = [];
fmean = [];
snr = [];
for s = 1:1:length(dirlistm)
    
    filename = dirlistb(s).name; %load .mat background image
    load(filename); % 4D 19f data 'image'
    bkg = inspiration;
    
    filename = dirlistm(s).name; %load .mat from MIM
    load(filename);
    mask = imresize((roi),[64 64]); % get lung mask, get 19F file 'image'
    
    %% VDP
    % find last wash-in
    def_mask = [];
    im_mash = [];
    total_ana = length(reshape(nonzeros(mask),[],1));
    for ti = 1:1:size(image,4)
        im_mash(ti) =  prctile(reshape(nonzeros(image(:,:,6:10,ti)),[],1),99.9); % get saturation
    end
    im_mash(im_mash<prctile(im_mash,75))=0;
    im_mash_diff = im_mash(1:end-1)-im_mash(2:end);
    [M,p] = max(im_mash_diff);
    
    maxv = image(:,:,:,p);
    
    %% get VDP masks
    p = 2;
    if (s == 2)||(s == 10)
        p = 1;
    end 
   for sl = 1:1:size(mask,3)
        thr = prctile(reshape(nonzeros(bkg(:,:,sl)),[],1),90); % get threshold
        def = image(:,:,sl,p)<=thr;
        nonvdp = image(:,:,sl,p)>thr;
        def_mask(:,:,sl) = def.*mask(:,:,sl);
        nonvdp_mask(:,:,sl) = nonvdp.*mask(:,:,sl);
    end
    total_def = length(reshape(nonzeros(def_mask),[],1));
    VDP(s) = (total_def*100)/total_ana;
    
    image_nvdp = image.*nonvdp_mask; % 19F with background and vdp removed
    
    tlc(s) = total_ana*6.25*6.24*15/1000; % total lung capacity (mL)
    
    fmean(s) = mean(nonzeros(image_nvdp(:,:,:,p))); % average 19F signal
    
    snr(s) = prctile(nonzeros(image_nvdp(:,:,:,p)),90)/std(reshape(bkg(5:60,5:60,1),[],1)); % snr calculation
    
    
end

m_out = [tlc' snr' VDP' fmean'];
