function [f19_vent_map, f19groups] = FindF19ThresholdKmeans(f19_lung)
%Determines low, medium, high ventilation threshold using MIP
% uses 1st and last slice of MIP which do not have f19 signal
% f19_lung = MIP image with outside lung set to value of 0

[r,c,v] = ind2sub(size(f19_lung),find(f19_lung > 0));
lung_data=f19_lung(f19_lung > 0);


%% Compute k-means clustering

idx = kmeans (lung_data,8,'MaxIter',300);
%Sort k-means to correct indecies (kmeans assigns random indecies)
[new_idx]=Sort1DKmean(lung_data,idx);
f19groups = zeros(size(f19_lung));
for i=1:size(new_idx)
    f19groups(r(i),c(i),v(i)) = new_idx(i);
end
 f19_vent_map = f19groups;
 f19_vent_map(f19_vent_map  == 3 | f19_vent_map  == 4 | f19_vent_map  == 5) = 3;
 f19_vent_map(f19_vent_map  == 6 | f19_vent_map  == 7 | f19_vent_map  == 8) = 4;
end