function [tau_vent_map, taugroups] = FindTauThresholdValues( tau )
% tau = entire tau map
% goups: mid_vent is 3,4 and 5, high_vent is 6,7 and 8, low_vent is 2, and no_vent
% is 1

%kmeans on either on Tau or 1/Tau
TauBool=0;

%tau(~tau) = inf;
if TauBool
    [r,c,v] = ind2sub(size(tau),find(tau > 0));
    lungTaus = tau(tau>0);
    idx = kmeans (lungTaus,8);
    [new_idx]=Sort1DKmean(lungTaus,idx);
else
    Rvals = (1./tau);
    [r,c,v] = ind2sub(size(Rvals),find(Rvals < Inf));
    lungRs = Rvals(Rvals < Inf);
    lungRs(lungRs > 0.2)=0.2; %group absurdly short times
    idx = kmeans (lungRs,8);
    [new_idx]=Sort1DKmean(lungRs,idx);
end
taugroups = zeros(size(tau));
for i=1:size(new_idx)
    taugroups(r(i),c(i),v(i)) = new_idx(i);
end
if TauBool    
    tau_vent_map = taugroups;
    tau_vent_map(tau_vent_map  == 1) = 12;
    tau_vent_map(tau_vent_map  == 2) = 12;
    tau_vent_map(tau_vent_map  == 3) = 12;
    tau_vent_map(tau_vent_map  == 4) = 11;
    tau_vent_map(tau_vent_map  == 5) = 11;
    tau_vent_map(tau_vent_map  == 6) = 11;
    tau_vent_map(tau_vent_map  == 7) = 10;
    tau_vent_map(tau_vent_map  == 8) = 9;
    tau_vent_map=tau_vent_map-8;
else
    tau_vent_map = taugroups;
    tau_vent_map(tau_vent_map  == 4 | tau_vent_map  == 5) = 3;
    tau_vent_map(tau_vent_map  == 6 | tau_vent_map  == 7 | tau_vent_map  == 8) = 4;
end