function [xenon_vent_map, xenongroups] = FindXenonThresholdKmeans(Xenon_lung)
%Determines low, medium, high ventilation threshold using MIP
% uses 1st and last slice of MIP which do not have f19 signal
% f19_lung = MIP image with outside lung set to value of 0

[r,c,v] = ind2sub(size(Xenon_lung),find(Xenon_lung > 0));
lung_data=Xenon_lung(Xenon_lung > 0);


%% Compute k-means clustering

idx = kmeans (lung_data,8,'MaxIter',300);
%Sort k-means to correct indecies (kmeans assigns random indecies)
[new_idx]=Sort1DKmean(lung_data,idx);
xenongroups = zeros(size(Xenon_lung));
for i=1:size(new_idx)
    xenongroups(r(i),c(i),v(i)) = new_idx(i);
end
 xenon_vent_map = xenongroups;
 xenon_vent_map(xenon_vent_map  == 3 | xenon_vent_map  == 4 | xenon_vent_map  == 5) = 3;
 xenon_vent_map(xenon_vent_map  == 6 | xenon_vent_map  == 7 | xenon_vent_map  == 8) = 4;
end