function [MIP,b] = MICO_3D_lung(Img,ROI)

iterNum_outer=15;  % outer iteration
iterCM=2;  % inner interation for C and M
Iter_b=1;  % inner iteration for bias
q = 1.5;   % fuzzifier
th_bg = 5;  % threshold for removing background
N_region = 1; % number of tissue types, e.g. WM, GM, CSF
tissueLabel=[1];
crop_image = 0;  % crop background for speed?

    
%%%%%%%%%%%%%%%%%%%%% Crop Background %%%%%%%%%%%%%%%
if crop_image == 1;
    [x1, x2, y1, y2, z1, z2] = cropImgROI(ROI);   %% crop image
    [DimX1, DimY1, DimZ1]=size(Img);
    x1 = max(1,x1-2); x2 = min(DimX1,x2+2);
    y1 = max(1,y1-2); y2 = min(DimY1,y2+2);
    z1 = max(1,z1-2); z2 = min(DimZ1,z2+2);

    Img3D=Img(x1:x2,y1:y2,z1:z2);
    ROI3D=ROI(x1:x2,y1:y2,z1:z2);
    clear Img;
    [DimX, DimY, DimZ] = size(Img3D);
    saveBasisOrder3_3D(ROI3D);    
    Img3D = Img3D.*ROI3D;
end
%%%%%%%%%%%%%%%%%%%%%%%% No Crop %%%%%%%%%%%%%%%%%%%%%
if crop_image == 0;
    Img3D=Img;
    ROI3D=ROI;
    clear Img;
    saveBasisOrder3_3D(ROI3D);
    [DimX, DimY, DimZ] = size(Img3D);
end
%%%%%%%%%%%%%%%%%%%%%% Initialization %%%%%%%%%%%%%%%%
    
A=max(Img3D(:));
C= linspace(0.1,0.9,N_region)*A;
b=ones(size(Img3D));
    
    
M=rand(DimX, DimY, DimZ,N_region);
a=sum(M,4);
for k = 1 : N_region
    M(:,:,:,k)=M(:,:,:,k)./a;
end
clear a;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[M, b, C]=  MICO_3D(Img3D,ROI3D,M,C,b,Iter_b, iterCM,q);
b(~b) = 1;
MIP = Img3D./b;


