function [tau_vent_map, taugroups] = FindTauThresholdValues( tau )
% tau = entire tau map
% goups: normal_vent is 3 and 4, high_vent is 5 and 6, low_vent is 2, and no_vent
% is 1

%kmans on either on Tau or 1/Tau
TauBool=0;

%tau(~tau) = inf;
if TauBool
    [r,c,v] = ind2sub(size(tau),find(tau > 0));
    lungTaus = tau(tau>0);
    idx = kmeans (lungTaus,6);
    [new_idx]=Sort1DKmean(lungTaus,idx);
else
    Rvals = (1./tau)
    [r,c,v] = ind2sub(size(Rvals),find(Rvals < Inf));
    lungRs = Rvals(Rvals < Inf);
    lungRs(lungRs > 0.2)=0.2; %group absurdly short times
    idx = kmeans (lungRs,6);
    [new_idx]=Sort1DKmean(lungRs,idx);
end
taugroups = zeros(size(tau));
for i=1:size(new_idx)
    taugroups(r(i),c(i),v(i)) = new_idx(i);
end
if TauBool    
    tau_vent_map = taugroups;
    tau_vent_map(tau_vent_map  == 1) = 10;
    tau_vent_map(tau_vent_map  == 2) = 10;
    tau_vent_map(tau_vent_map  == 3) = 9;
    tau_vent_map(tau_vent_map  == 4) = 9;
    tau_vent_map(tau_vent_map  == 5) = 8;
    tau_vent_map(tau_vent_map  == 6) = 7;
    tau_vent_map=tau_vent_map-6;
else
    tau_vent_map = taugroups;
    tau_vent_map(tau_vent_map  == 4) = 3;
    tau_vent_map(tau_vent_map  == 5 | tau_vent_map  == 6) = 4;
end