function [ RGB_F19_MATRIX UnventilatedMap MinimalVentMap ModerateVentMap HighVentMap ] = PlotRGB_Tau( patientNumber, PlotRGBImageBool,SaveRGBImageBool,tau_vent_map)
%Creates RGB matrix for f19 MIP and plots resulting rgb image

%% Create RGB Array for f19 MIP image using thresholding
% preallocate for speed
RGB_F19_MATRIX  = zeros(size(tau_vent_map,1),size(tau_vent_map,2),size(tau_vent_map,3),3,'uint8');
UnventilatedMap = zeros(size(tau_vent_map,1),size(tau_vent_map,2),size(tau_vent_map,3),'uint8');
MinimalVentMap  = zeros(size(tau_vent_map,1),size(tau_vent_map,2),size(tau_vent_map,3),'uint8');
ModerateVentMap = zeros(size(tau_vent_map,1),size(tau_vent_map,2),size(tau_vent_map,3),'uint8');
HighVentMap     = zeros(size(tau_vent_map,1),size(tau_vent_map,2),size(tau_vent_map,3),'uint8');

for slice=1:size(tau_vent_map,3)
    for row = 1:size(tau_vent_map,1)
        for col = 1:size(tau_vent_map,2)
            if  tau_vent_map(row,col,slice)==1
                % color black
                RGB_F19_MATRIX(row,col,slice,1) = 50;
                RGB_F19_MATRIX(row,col,slice,2) = 50;
                RGB_F19_MATRIX(row,col,slice,3) = 50;
                
                UnventilatedMap(row,col,slice) = 1;
                
            elseif tau_vent_map(row,col,slice)==2
                % color red
                RGB_F19_MATRIX(row,col,slice,1) = 225;
                RGB_F19_MATRIX(row,col,slice,2) = 0;
                RGB_F19_MATRIX(row,col,slice,3) = 0;
                
                MinimalVentMap(row,col,slice) = 1;
                
            elseif tau_vent_map(row,col,slice)==3
                % color yellow
                RGB_F19_MATRIX(row,col,slice,1) = 225;
                RGB_F19_MATRIX(row,col,slice,2) = 225;
                RGB_F19_MATRIX(row,col,slice,3) = 75;
                
                ModerateVentMap(row,col,slice) = 1;
                
            elseif tau_vent_map(row,col,slice)==4
                % color green
                RGB_F19_MATRIX(row,col,slice,1) = 0;
                RGB_F19_MATRIX(row,col,slice,2) = 152;
                RGB_F19_MATRIX(row,col,slice,3) = 51;
                
                HighVentMap(row,col,slice) = 1;
                
            end
        end
    end
end

% Plot RGB Image on Figure 2

if PlotRGBImageBool
    
    figure(2);clf
    
    subplot(4,4,1)
    imshow(squeeze(RGB_F19_MATRIX(:,:,2,:)))
    title(sprintf('Subject %s', patientNumber))
    subplot(4,4,2)
    imshow(squeeze(RGB_F19_MATRIX(:,:,3,:)))
    subplot(4,4,3)
    imshow(squeeze(RGB_F19_MATRIX(:,:,4,:)))
    subplot(4,4,4)
    imshow(squeeze(RGB_F19_MATRIX(:,:,5,:)))
    subplot(4,4,5)
    imshow(squeeze(RGB_F19_MATRIX(:,:,6,:)))
    subplot(4,4,6)
    imshow(squeeze(RGB_F19_MATRIX(:,:,7,:)))
    subplot(4,4,7)
    imshow(squeeze(RGB_F19_MATRIX(:,:,8,:)))
    subplot(4,4,8)
    imshow(squeeze(RGB_F19_MATRIX(:,:,9,:)))
    subplot(4,4,9)
    imshow(squeeze(RGB_F19_MATRIX(:,:,10,:)))
    subplot(4,4,10)
    imshow(squeeze(RGB_F19_MATRIX(:,:,11,:)))
    subplot(4,4,11)
    imshow(squeeze(RGB_F19_MATRIX(:,:,12,:)))
    subplot(4,4,12)
    imshow(squeeze(RGB_F19_MATRIX(:,:,13,:)))
    subplot(4,4,13)
    imshow(squeeze(RGB_F19_MATRIX(:,:,14,:)))
    subplot(4,4,14)
    imshow(squeeze(RGB_F19_MATRIX(:,:,15,:)))
    if size(tau_vent_map,3)>16
        subplot(4,4,15)
        imshow(squeeze(RGB_F19_MATRIX(:,:,16,:)))
    end
    if size(tau_vent_map,3)>17
        subplot(4,4,16)
        imshow(squeeze(RGB_F19_MATRIX(:,:,17,:)))
    end
    pause(0.1)
end

%% Save figure (optional)
if SaveRGBImageBool
    FigureDirectory    = strcat('.\outputs\RGB_f19\');  mkdir(FigureDirectory);
    FigureName = strcat('f19Tau_RGB_Patient_',string(patientNumber));
    FileName = char(strcat(FigureDirectory,FigureName,'.png'));
    saveas(gcf,FileName)
    FigureDirectory2    = strcat('.\outputs\RGB_f19\');  mkdir(FigureDirectory2);
    FigureName2 = strcat('TauVentMap_Patient_',string(patientNumber));
    FileName2 = char(strcat(FigureDirectory2,FigureName2,'.mat'));
    save(FileName2,'tau_vent_map')

end

end

