clear all
close all

subt = ['005'; '006'; '007'; '008'; '009'; '010'; '011'; '012'; '013'; '015'];


for s = 1:1:10
    
    filename = strcat('bkgx_',subt(s,:),'.mat'); %load .mat background image
    load(filename); % 4D 19f data 'image'
    bkg = inspiration;
    
    filename = strcat('2569-',subt(s,:),'-rois.mat'); %load .mat roi
    load(filename); % ROI1 ROI2 ROI3
    ROI1 = imresize(ROI1,[64 64]); % Xe+ 19F-
    ROI2 = imresize(ROI2,[64 64]); % Xe+ 19F+
    ROI3 = imresize(ROI3,[64 64]); % Xe- 19F+
  
    filename = strcat('2569-',subt(s,:),'_19F_nm_MIM_mask.mat'); %load .mat from MIM
    load(filename); % 4D 19f data 'image'
    
    %% order background d0 to xyz
    
    x_a = [0:1:63];
    z_a = [0:1:17];
    y_a = [0:1:63];
    
    
    d0xyz = zeros(64*64*18,1);
    count = 1;
    for i = 1:1:18 %scan
        for j = 1:1:64 %column
            for k = 1:1:64 %row
                %            d0xyz(count,1) = d0m(k,j,i);
                d0xyz(count,1) = bkg(k,j,i);
                %            d0xyz(count,1:3) = [x_a(j) y_a(k) z_a(i)];
                count = count +1;
            end
        end
    end
    
    x_a = [0:1:63];
    z_a = [0:1:17];
    y_a = [0:1:63];
    
    
    ROI1xyz = [];
    count = 1;
    for i = 1:1:18 %scan
        for j = 1:1:64 %column
            for k = 1:1:64 %row
                ROI1xyz(count,1) = ROI1(k,j,i);
                %            d0xyz(count,1:3) = [x_a(j) y_a(k) z_a(i)];
                count = count +1;
            end
        end
    end
    x_a = [0:1:63];
    z_a = [0:1:17];
    y_a = [0:1:63];
    
    
    ROI2xyz = [];
    count = 1;
    for i = 1:1:18 %scan
        for j = 1:1:64 %column
            for k = 1:1:64 %row
                ROI2xyz(count,1) = ROI2(k,j,i);
                %            d0xyz(count,1:3) = [x_a(j) y_a(k) z_a(i)];
                count = count +1;
            end
        end
    end
    x_a = [0:1:63];
    z_a = [0:1:17];
    y_a = [0:1:63];
    
    
    ROI3xyz = [];
    count = 1;
    for i = 1:1:18 %scan
        for j = 1:1:64 %column
            for k = 1:1:64 %row
                ROI3xyz(count,1) = ROI3(k,j,i);
                %            d0xyz(count,1:3) = [x_a(j) y_a(k) z_a(i)];
                count = count +1;
            end
        end
    end
    
    %% apply MIM mask
    ROI1_t = [];
    ROI2_t = [];
    ROI3_t = [];
    for j=1:1:size(image,4)
        ROI1_t(:,:,:,j) = image(:,:,:,j).*ROI1; %Xe only
        ROI2_t(:,:,:,j) = image(:,:,:,j).*ROI2; %both
        ROI3_t(:,:,:,j) = image(:,:,:,j).*ROI3; %f19 only
    end
    
    
    %% order F19 to xyz form
    fitdata = zeros(64*64*18,size(image,4)+3);
    fitdata1 = zeros(64*64*18,size(image,4)+3); % Xe+ 19F-
    fitdata2 = zeros(64*64*18,size(image,4)+3); % Xe+ 19F+
    fitdata3 = zeros(64*64*18,size(image,4)+3); % Xe- 19F+
    count = 1;
    for i = 1:1:18 %scanj =
        for j = 1:1:64 %column
            for k = 1:1:64 %row
                fitdata(count,4:size(image,4)+3) = image(k,j,i,:);
                fitdata(count,1:3) = [x_a(j) y_a(k) z_a(i)];
                
                fitdata1(count,4:size(image,4)+3) = ROI1_t(k,j,i,:);
                fitdata1(count,1:3) = [x_a(j) y_a(k) z_a(i)];
                
                fitdata2(count,4:size(image,4)+3) = ROI2_t(k,j,i,:);
                fitdata2(count,1:3) = [x_a(j) y_a(k) z_a(i)];
                
                fitdata3(count,4:size(image,4)+3) = ROI3_t(k,j,i,:);
                fitdata3(count,1:3) = [x_a(j) y_a(k) z_a(i)];
                count = count +1;
            end
        end
    end
    
    %% Remove zero rows
    fitdataMR = [];
    fitdataMR1 = [];
    fitdataMR2 = [];
    fitdataMR3 = [];
    d0xyzcol = [];
    d0xyzcol1 = [];
    d0xyzcol2 = [];
    d0xyzcol3 = [];
    count = 1;
    for i=1:size(fitdata,1)
        if (fitdata(i,4)~=0) || (fitdata(i,5)~=0)%choose column to use
            fitdataMR(count,:) = fitdata(i,:);
            d0xyzcol(count,:) = d0xyz(i,:);
            count = count + 1;
        end
    end
    count = 1;
    for i=1:size(fitdata1,1)
        if (ROI1xyz(i)~=0)%choose column to use
            fitdataMR1(count,:) = fitdata1(i,:);
            d0xyzcol1(count,:) = d0xyz(i,:);
            count = count + 1;
        end
    end
    xe_only = mean(fitdataMR1,1);
    xe_only_d0 = mean(d0xyzcol1,1);
    count = 1;
    for i=1:size(fitdata2,1)
        if (ROI2xyz(i)~=0)%choose column to use
            fitdataMR2(count,:) = fitdata2(i,:);
            d0xyzcol2(count,:) = d0xyz(i,:);
            count = count + 1;
        end
    end
    xe_f19 = mean(fitdataMR2,1);
    xe_f19_d0 = mean(d0xyzcol2,1);
    count = 1;
    for i=1:size(fitdata3,1)
        if (ROI3xyz(i)~=0)%choose column to use
            fitdataMR3(count,:) = fitdata3(i,:);
            d0xyzcol3(count,:) = d0xyz(i,:);
            count = count + 1;
        end
    end
    f19_only = mean(fitdataMR3,1);
    f19_only_d0 = mean(d0xyzcol3,1);
    
    fitdata_avg = [xe_only; xe_f19; f19_only];
    d0_avg = [xe_only_d0; xe_f19_d0; f19_only_d0];
    
    time = scantimes;
    
    
    %% check plot raw 19F and WO fit
    figure
    Mfitout = [];
    
    for vi = 1:1:3
        line = vi;
        
        Fdata = fitdata_avg(line,4:end);
        
        d0 = d0_avg(line);
        
        %%
        
        vtime = 0:1:size(time,1)-1;
        offset = size(time,1)/3;
        wvector = 3*(sin(((vtime+offset)*3.14159265)./(size(time,1)+offset-1)))+0.5;
        wvector = wvector/(max(wvector)); %normalize to zero (matlab fit format requirement)
        
        eqn1 = 'd0+(x<t1)*peak*[1 - exp(-((1.0/tau1)*(x - t0)))] + (x>=t1)*peak*[ [1 - exp(-((1.0/tau1)*(t1 - t0)))]*[exp(-((1.0/tau2)*(x - t1)))] ]'; % new equation
        
        myfit1 = fittype(eqn1,'coefficients',{'peak','t0','t1','tau1','tau2'},'problem','d0');
        
        low1 =   [0,-45,50,1,1];
        start1 = [8,-40,140,25,25];
        up1 =    [500,20,346,2000,2000];
        
        %% Fit
        options = fitoptions('Method', 'NonlinearLeastSquares','Lower',low1,'Upper',up1,'StartPoint',start1,'Weights',wvector);
        
        [fitout1,gof,output] = fit(time,Fdata',myfit1,options,'problem',d0);
        
        
        %%
        
        Mfitout = [Mfitout ; fitdataMR(line,1:3) fitout1.peak fitout1.tau1 fitout1.tau2 fitout1.t0 fitout1.t1 d0 gof.rmse gof.rsquare Fdata];
        
        gtitle = {'Xe+ F19-';'Xe+ F19+';'Xe- F19+'};
        
        plot(fitout1,time,Fdata') % plots fit
        hold on
        scatter(time, Fdata,'o');
        
        set(gcf,'position',[1472,764,289,246])
        title(gtitle(line,:))
        xlabel('Time (s)')
        ylabel('Average voxel intensity')
        s
        hold on
    end
    
    filename = strcat('2569-',subt(s,:),'_roi_new_eq.mat');
    save(filename,'fitdataMR','Mfitout','fitdataMR1','fitdataMR2','fitdataMR3')
    
end